// **********************************************************************
//
// Copyright (c) 2003
// ZeroC, Inc.
// Billerica, MA, USA
//
// All Rights Reserved.
//
// Ice is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License version 2 as published by
// the Free Software Foundation.
//
// **********************************************************************

// Ice version 1.2.0
// Generated from file `JLib.ice'

#include <JLib.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 10200
#       error Ice version mismatch!
#   endif
#endif

void
IceInternal::incRef(::JLib* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::JLib* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::JLib* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::JLib* p)
{
    p->__decRef();
}

void
IceInternal::checkedCast(const ::Ice::ObjectPrx& b, ::JLibPrx& d)
{
    d = 0;
    if(b.get())
    {
	d = dynamic_cast< ::IceProxy::JLib*>(b.get());
	if(!d && b->ice_isA("::JLib"))
	{
	    d = new ::IceProxy::JLib;
	    d->__copyFrom(b);
	}
    }
}

void
IceInternal::checkedCast(const ::Ice::ObjectPrx& b, const ::std::string& f, ::JLibPrx& d)
{
    d = 0;
    if(b)
    {
	::Ice::ObjectPrx bb = b->ice_appendFacet(f);
	try
	{
	    if(bb->ice_isA("::JLib"))
	    {
		d = new ::IceProxy::JLib;
		d->__copyFrom(bb);
	    }
	}
	catch(const ::Ice::FacetNotExistException&)
	{
	}
    }
}

void
IceInternal::uncheckedCast(const ::Ice::ObjectPrx& b, ::JLibPrx& d)
{
    d = 0;
    if(b)
    {
	d = dynamic_cast< ::IceProxy::JLib*>(b.get());
	if(!d)
	{
	    d = new ::IceProxy::JLib;
	    d->__copyFrom(b);
	}
    }
}

void
IceInternal::uncheckedCast(const ::Ice::ObjectPrx& b, const ::std::string& f, ::JLibPrx& d)
{
    d = 0;
    if(b)
    {
	::Ice::ObjectPrx bb = b->ice_appendFacet(f);
	d = new ::IceProxy::JLib;
	d->__copyFrom(bb);
    }
}

void
__write(::IceInternal::BasicStream* __os, const ::JLibPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
__read(::IceInternal::BasicStream* __is, ::JLibPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::JLib;
	v->__copyFrom(proxy);
    }
}

void
__write(::IceInternal::BasicStream* __os, const ::JLibPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

::std::string
IceProxy::JLib::invokeFunction(const ::std::string& JLibXMLPackage)
{
    return invokeFunction(JLibXMLPackage, __defaultContext());
}

::std::string
IceProxy::JLib::invokeFunction(const ::std::string& JLibXMLPackage, const ::Ice::Context& __ctx)
{
    int __cnt = 0;
    while(true)
    {
	try
	{__checkTwowayOnly("invokeFunction");
	    ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase = __getDelegate();
	    ::IceDelegate::JLib* __del = dynamic_cast< ::IceDelegate::JLib*>(__delBase.get());
	    return __del->invokeFunction(JLibXMLPackage, __ctx);
	}
	catch(const ::IceInternal::NonRepeatable& __ex)
	{
	    __rethrowException(*__ex.get());
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    __handleException(__ex, __cnt);
	}
    }
}

void
IceProxy::JLib::invokeMethod(const ::std::string& JLibXMLPackage)
{
    invokeMethod(JLibXMLPackage, __defaultContext());
}

void
IceProxy::JLib::invokeMethod(const ::std::string& JLibXMLPackage, const ::Ice::Context& __ctx)
{
    int __cnt = 0;
    while(true)
    {
	try
	{
	    ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase = __getDelegate();
	    ::IceDelegate::JLib* __del = dynamic_cast< ::IceDelegate::JLib*>(__delBase.get());
	    __del->invokeMethod(JLibXMLPackage, __ctx);
	    return;
	}
	catch(const ::IceInternal::NonRepeatable& __ex)
	{
	    __rethrowException(*__ex.get());
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    __handleException(__ex, __cnt);
	}
    }
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::JLib::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::JLib);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::JLib::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::JLib);
}

bool
IceProxy::operator==(const ::IceProxy::JLib& l, const ::IceProxy::JLib& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::operator!=(const ::IceProxy::JLib& l, const ::IceProxy::JLib& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::operator<(const ::IceProxy::JLib& l, const ::IceProxy::JLib& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

::std::string
IceDelegateM::JLib::invokeFunction(const ::std::string& JLibXMLPackage, const ::Ice::Context& __context)
{
    static const ::std::string __operation("invokeFunction");
    ::IceInternal::Outgoing __out(__connection.get(), __reference.get(), __operation, static_cast< ::Ice::OperationMode>(0), __context);
    ::IceInternal::BasicStream* __is = __out.is();
    ::IceInternal::BasicStream* __os = __out.os();
    __os->write(JLibXMLPackage);
    if(!__out.invoke())
    {
	throw ::Ice::UnknownUserException(__FILE__, __LINE__);
    }
    ::std::string __ret;
    try
    {
	__is->read(__ret);
    }
    catch(const ::Ice::LocalException& __ex)
    {
	throw ::IceInternal::NonRepeatable(__ex);
    }
    return __ret;
}

void
IceDelegateM::JLib::invokeMethod(const ::std::string& JLibXMLPackage, const ::Ice::Context& __context)
{
    static const ::std::string __operation("invokeMethod");
    ::IceInternal::Outgoing __out(__connection.get(), __reference.get(), __operation, static_cast< ::Ice::OperationMode>(0), __context);
    ::IceInternal::BasicStream* __os = __out.os();
    __os->write(JLibXMLPackage);
    if(!__out.invoke())
    {
	throw ::Ice::UnknownUserException(__FILE__, __LINE__);
    }
}

::std::string
IceDelegateD::JLib::invokeFunction(const ::std::string& JLibXMLPackage, const ::Ice::Context& __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, "invokeFunction", static_cast< ::Ice::OperationMode>(0), __context);
    while(true)
    {
	::IceInternal::Direct __direct(__current);
	::JLib* __servant = dynamic_cast< ::JLib*>(__direct.facetServant().get());
	if(!__servant)
	{
	    ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
	    __opEx.id = __current.id;
	    __opEx.facet = __current.facet;
	    __opEx.operation = __current.operation;
	    throw __opEx;
	}
	try
	{
	    return __servant->invokeFunction(JLibXMLPackage, __current);
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    throw ::IceInternal::NonRepeatable(__ex);
	}
    }
}

void
IceDelegateD::JLib::invokeMethod(const ::std::string& JLibXMLPackage, const ::Ice::Context& __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, "invokeMethod", static_cast< ::Ice::OperationMode>(0), __context);
    while(true)
    {
	::IceInternal::Direct __direct(__current);
	::JLib* __servant = dynamic_cast< ::JLib*>(__direct.facetServant().get());
	if(!__servant)
	{
	    ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
	    __opEx.id = __current.id;
	    __opEx.facet = __current.facet;
	    __opEx.operation = __current.operation;
	    throw __opEx;
	}
	try
	{
	    __servant->invokeMethod(JLibXMLPackage, __current);
	    return;
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    throw ::IceInternal::NonRepeatable(__ex);
	}
    }
}

const ::std::string JLib::__ids[2] =
{
    "::Ice::Object",
    "::JLib"
};

bool
JLib::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__ids, __ids + 2, _s);
}

::std::vector< ::std::string>
JLib::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__ids[0], &__ids[2]);
}

const ::std::string&
JLib::ice_id(const ::Ice::Current&) const
{
    return __ids[1];
}

const ::std::string&
JLib::ice_staticId()
{
    return __ids[1];
}

void
JLib::__gcReachable(::IceUtil::GCObjectMultiSet& _c) const
{
#if defined(_MSC_VER) && (MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__gcReachable(_c);
#else
    ::Ice::Object::__gcReachable(_c);
#endif
}

void
JLib::__gcClear()
{
#if defined(_MSC_VER) && (MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__gcClear();
#else
    ::Ice::Object::__gcClear();
#endif
}

::IceInternal::DispatchStatus
JLib::___invokeFunction(::IceInternal::Incoming& __in, const ::Ice::Current& __current)
{
    ::IceInternal::BasicStream* __is = __in.is();
    ::IceInternal::BasicStream* __os = __in.os();
    ::std::string JLibXMLPackage;
    __is->read(JLibXMLPackage);
    ::std::string __ret = invokeFunction(JLibXMLPackage, __current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
JLib::___invokeMethod(::IceInternal::Incoming& __in, const ::Ice::Current& __current)
{
    ::IceInternal::BasicStream* __is = __in.is();
    ::std::string JLibXMLPackage;
    __is->read(JLibXMLPackage);
    invokeMethod(JLibXMLPackage, __current);
    return ::IceInternal::DispatchOK;
}

::std::string JLib::__all[] =
{
    "ice_facets",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "invokeFunction",
    "invokeMethod"
};

::IceInternal::DispatchStatus
JLib::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__all, __all + 7, current.operation);
    if(r.first == r.second)
    {
	return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __all)
    {
	case 0:
	{
	    return ___ice_facets(in, current);
	}
	case 1:
	{
	    return ___ice_id(in, current);
	}
	case 2:
	{
	    return ___ice_ids(in, current);
	}
	case 3:
	{
	    return ___ice_isA(in, current);
	}
	case 4:
	{
	    return ___ice_ping(in, current);
	}
	case 5:
	{
	    return ___invokeFunction(in, current);
	}
	case 6:
	{
	    return ___invokeMethod(in, current);
	}
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
JLib::__write(::IceInternal::BasicStream* __os, bool __marshalFacets) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os, __marshalFacets);
#else
    ::Ice::Object::__write(__os, __marshalFacets);
#endif
}

void
JLib::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is);
#else
    ::Ice::Object::__read(__is);
#endif
}

void 
::__patch__JLibPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::JLibPtr* p = static_cast< ::JLibPtr*>(__addr);
    assert(p);
    *p = ::JLibPtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::JLib::ice_staticId();
	throw e;
    }
}

bool
operator==(const ::JLib& l, const ::JLib& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
operator!=(const ::JLib& l, const ::JLib& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
operator<(const ::JLib& l, const ::JLib& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
